<template>
  <label
    class="ui-input"
    :style="styleList"
  >
    <input
      class="input flex-1"
      v-model="value"
      @input="handleInput"
      :placeholder="placeholder"
      :inputmode="inputmode"
    />
    <div
      class="postfix"
    >
      <slot name="postfix"></slot>
    </div>
  </label>
</template>

<script lang="ts">
  import { defineComponent, computed, HTMLAttributes, PropType } from 'vue'
  import get from 'lodash.get'
  import { uiCalcRounded } from '../../utils/uiCalcRounded'

  export default defineComponent({
    props: {
      value: [String, Number],
      placeholder: {
        type: String,
        default: '',
      },
      inputmode: {
        type: String as PropType<HTMLAttributes['inputmode']>,
        default: 'text',
      },
      size: {
        type: Number,
        default: 50,
      }
    },
    emits: ['update:value', 'input'],
    setup(props, { emit }) {
      const styleList = computed(() => {
        const { size } = props

        return {
          height: `${size}px`,
          minWidth: `${size}px`,
          borderRadius: `${uiCalcRounded(size)}px`,
        }
      })
      const handleInput = (event: Event) => {
        emit('input', get(event, ['target', 'value'], ''))
      }

      return {
        styleList,
        handleInput,
      }
    },
  })
</script>

<style>
  .ui-input {
    display: flex;
    align-items: stretch;
    @apply uikit-px-18 uikit-text-14 uikit-transition-colors uikit-duration-200;;
  }

  .ui-input > .postfix {
    @apply uikit-flex uikit-flex-grow-0 uikit-justify-center uikit-items-center uikit-relative uikit-pl-12;
  }

  .ui-input > .postfix::before {
    content: '';
    @apply uikit-block uikit-absolute uikit-h-full uikit-w-24 uikit-bg-gradient-to-r uikit-from-transparent uikit-to-black uikit-right-full uikit-top-0 uikit-pointer-events-none
  }

  .ui-input {
    @apply uikit-bg-black uikit-text-white uikit-border uikit-border-white uikit-border-opacity-20;
  }

  .ui-input:hover {
    @apply uikit-border-opacity-40;
  }

  .ui-input:focus-within {
    @apply uikit-border-opacity-100;
  }

  .ui-input > .input {
    @apply uikit-bg-transparent uikit-outline-none uikit-border-0 uikit-placeholder-white uikit-placeholder-opacity-60;
    width: 100px;
  }
</style>
